Package org.jfree.layouting.normalizer.content

## Interface Normalizer

- All Superinterfaces:
    `StatefullComponent`
  All Known Implementing Classes:
    `ChainingNormalizer`, `ContentNormalizer`, `RecordingContentNormalizer`

      public interface Normalizer
      extends StatefullComponent

  The normalizer is the first stage of the content processing. A normalizer is responsible for auto-generating content and for assigning styles to the logical document tree.
  Author:
    Thomas Morgner

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addText​(java.lang.String text)` | Adds text content to the current element.
    `void` | `endDocument​()` | Ends the document.
    `void` | `endElement​()` | Ends the current element.
    `Renderer` | `getRenderer​()` | Returns the renderer.
    `void` | `handlePageBreak​(CSSValue pageName, PseudoPage[] pseudoPages)` |
    `void` | `startDocument​()` | Start document is the first call to the normalizer.
    `void` | `startElement​(java.lang.String namespace, java.lang.String tag, AttributeMap attributes)` | Starts a new element.

    - ### Methods inherited from interface org.jfree.layouting.StatefullComponent

      `saveState`

- - ### Method Detail

    - #### startDocument

          void startDocument​()
                      throws NormalizationException,
                             java.io.IOException

      Start document is the first call to the normalizer. At this point, all meta-data has been given and the document context is filled correctly. Starting the document also starts a new PageContext.
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### startElement

          void startElement​(java.lang.String namespace,
                            java.lang.String tag,
                            AttributeMap attributes)
                     throws NormalizationException,
                            java.io.IOException

      Starts a new element. The element uses the given namespace and tagname. The element's attributes are given as collection, each attribute is keyed with a namespace and attributename. The values contained in the attributes are not defined.
      Parameters:
        `namespace` -
        `tag` -
        `attributes` -
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### addText

          void addText​(java.lang.String text)
                throws NormalizationException,
                       java.io.IOException

      Adds text content to the current element.
      Parameters:
        `text` -
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### endElement

          void endElement​()
                   throws NormalizationException,
                          java.io.IOException

      Ends the current element. The namespace and tagname are given for convienience.
      Parameters:
        `namespace` -
        `tag` -
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### endDocument

          void endDocument​()
                    throws NormalizationException,
                           java.io.IOException

      Ends the document. No other events will be fired against this normalizer once this method has been called.
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### handlePageBreak

          void handlePageBreak​(CSSValue pageName,
                               PseudoPage[] pseudoPages)
                        throws NormalizationException

      Throws:
        `NormalizationException`

    - #### getRenderer

          Renderer getRenderer​()

      Returns the renderer. The renderer is the last step in the processing chain. The ModelBuilder and ContentGenerator steps are considered internal, as they may refeed the normalizer.
      Returns: